import java.util.List;

interface SchemeValue {
    public boolean isBool();
    public boolean isInt();
    public boolean isString();
    public boolean isSymbol();
    public boolean isPair();
    public boolean asBool() throws SchemeException;
    public int asInt() throws SchemeException;
    public String asString() throws SchemeException;
    public String asSymbol() throws SchemeException;
    public SchemePairValue asPair() throws SchemeException;
    public SchemeValue applyTo(List args) throws SchemeException;
    public String toString();
}
